diff -ur sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2019-02-15 09:37:36.768000000 +1000
+++ source/scripts/jmgUtility.cpp	2019-06-22 07:43:44.244400000 +1000
@@ -11,6 +11,7 @@
 #include "BuildingGameObj.h"
 #include "engine_player.h"
 #include "DefinitionMgrClass.h"
+#include "AudibleSoundDefinitionClass.h"
 bool JmgUtility::hasStatedDeathMessage[128] = {false};
 
 void JMG_Utility_Check_If_Script_Is_In_Library::Created(GameObject *obj)
@@ -197,9 +198,11 @@
 void JMG_Utility_Display_HUD_Info_Text_All_Players_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == Get_Int_Parameter("Custom"))
+	{
 		JmgUtility::SetHUDHelpText(Get_Int_Parameter("StringId"),Get_Vector3_Parameter("ColorRGB"));
-	if (!Get_Int_Parameter("Repeatable"))
-		Destroy_Script();
+		if (!Get_Int_Parameter("Repeatable"))
+			Destroy_Script();
+	}
 }
 void JMG_Utility_Display_HUD_Info_Text_To_Sender_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -313,9 +316,7 @@
 }
 void JMG_Turret_Spawn::Killed(GameObject *obj,GameObject *killer)
 {
-	GameObject *turret = Commands->Find_Object(turretId);
-	if (turret)
-		Commands->Destroy_Object(turret);
+	Destroyed(obj);
 }
 void JMG_Turret_Spawn::Destroyed(GameObject *obj)
 {
@@ -323,6 +324,12 @@
 	if (turret)
 		Commands->Destroy_Object(turret);
 }
+void JMG_Turret_Spawn::Detach(GameObject *obj)
+{
+	if (Exe == 4)
+		return;
+	Destroyed(obj);
+}
 ClientNetworkObjectPositionSync *clientNetworkObjectPositionSyncControl = NULL;
 void JMG_Utility_Sync_System_Object::Created(GameObject *obj)
 {
@@ -401,6 +408,10 @@
 	clientNetworkObjectPositionSyncControl->Empty_List();
 	clientNetworkObjectPositionSyncControl = NULL;
 }
+void JMG_Utility_Sync_System_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Sync_Object_Periodically::Created(GameObject *obj)
 {
 	Commands->Start_Timer(obj,this,0.25f,1);
@@ -419,6 +430,7 @@
 	spawnedId = 0;
 	spawnLimit = Get_Int_Parameter("SpawnLimit");
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
+	attachScriptsGroupId = Get_Int_Parameter("Attach_Scripts_Group_ID");
 	CalculateRespawnTime();
 	Commands->Disable_All_Collisions(obj);
 	Commands->Set_Is_Rendered(obj,false);
@@ -447,7 +459,7 @@
 					char params[256];
 					sprintf(params,"%d",Commands->Get_ID(obj));
 					Commands->Attach_Script(spawnedObject,"JMG_Utility_Basic_Spawner_Spawned_Object",params);
-					Commands->Send_Custom_Event(spawnedObject,obj,6873522,6873522,0.0f);
+					Commands->Send_Custom_Event(spawnedObject,obj,6873522,attachScriptsGroupId,0.0f);
 				}
 				else
 				{
@@ -566,6 +578,8 @@
 		return;
 	if (aiIgnorePlayers[JmgUtility::JMG_Get_Player_ID(seen)])
 		return;
+	if (!Commands->Get_Health(seen))
+		return;
 	targetId = Commands->Get_ID(seen);
 	targetUpdate = 20;
 }
@@ -965,6 +979,8 @@
 		return;
 	if (Get_Float_Parameter("MinAttackRange") && dist < minDistanceSquared)
 		return;
+	if (!Commands->Get_Health(seen))
+		return;
 	if (seen->As_SmartGameObj() && seen->As_SmartGameObj()->Is_Stealthed())
 		if (seen->As_SoldierGameObj() && dist > seen->As_SoldierGameObj()->Get_Stealth_Fade_Distance()*seen->As_SoldierGameObj()->Get_Stealth_Fade_Distance())
 			return;
@@ -1503,6 +1519,10 @@
 {
 	controllerPlaced = false;
 }
+void JMG_Utility_Play_Music_On_Join_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Play_Music_On_Join_Controller::Set_Music(const char *musicFilName,int fadeOut,int fadeIn)
 {
 	sprintf(JMG_Utility_Play_Music_On_Join_Controller::musicFileName,"%s",musicFilName);
@@ -1801,9 +1821,11 @@
 void JMG_Utility_Display_HUD_Info_Text_All_Players_Custom_Replace_String::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == Get_Int_Parameter("Custom"))
+	{
 		JmgUtility::SetHUDHelpText(Get_Int_Parameter("StringId"),Get_Parameter("ReplaceString"),Get_Vector3_Parameter("ColorRGB"));
-	if (!Get_Int_Parameter("Repeatable"))
-		Destroy_Script();
+		if (!Get_Int_Parameter("Repeatable"))
+			Destroy_Script();
+	}
 }
 void JMG_Utility_Display_Text_Message_To_All_Players_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -1852,6 +1874,8 @@
 }
 void JMG_Utility_AI_Aggressive_Melee::Enemy_Seen(GameObject *obj,GameObject *seen)	
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	int SeenID = Commands->Get_ID(seen);
 	if (!currentTargetID || !LastSeen)
 	{
@@ -2498,11 +2522,18 @@
 }
 void JMG_Utility_AI_Guardian_Aircraft::Created(GameObject *obj)
 {
+	newPointDelay = Get_Int_Parameter("NewPointDelay");
+	remainingDelay = 0;
 	dpPosition = Commands->Get_Position(obj);
 	EnemyID = 0;
 	EnemyTimeOutTime = 0;
 	LastPos = Commands->Get_Position(obj);
 	stealthModeOverride = Get_Int_Parameter("StealthModeOverride");
+	float weaponRange = 0.0f;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	if (ammo)
+		weaponRange = ammo->Range;
+	fireRange = Get_Float_Parameter("FireRange") >= 0 ? Get_Float_Parameter("FireRange") : weaponRange;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Enable_Engine(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
@@ -2530,9 +2561,14 @@
 		Vector3 Pos = Commands->Get_Position(obj);
 		if (JmgUtility::SimpleDistance(Pos,LastPos) < 25.0)
 		{
-			if (Get_A_Defense_Point(&dpPosition))
+			if (!remainingDelay && Get_A_Defense_Point(&dpPosition))
+			{
+				remainingDelay = newPointDelay;
 				Goto_Location(obj);
+			}
 		}
+		if (remainingDelay)
+			remainingDelay--;
 		LastPos = Pos;
 		Commands->Start_Timer(obj,this,1.0f,1);
 	}
@@ -2543,6 +2579,8 @@
 		return;
 	if (!JmgUtility::CanSeeStealth(stealthModeOverride,obj,seen))
 		return;
+	if (!Commands->Get_Health(seen))
+		return;
 	if (!EnemyID || !EnemyTimeOutTime)
 	{
 		EnemyID = Commands->Get_ID(seen);
@@ -2576,7 +2614,7 @@
 			params.Set_Face_Location(Commands->Get_Position(Target),5.0f);
 		else
 			params.AttackFaceTarget = false;
-		params.Set_Attack(Target,Get_Float_Parameter("FireRange"),0,true);
+		params.Set_Attack(Target,fireRange,0,true);
 		Commands->Action_Attack(obj,params);
 	}
 	else
@@ -2748,6 +2786,8 @@
 		return;
 	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
 		return;
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Get_Int_Parameter("CanSeeStealth") != 2 && seen->As_SmartGameObj() && seen->As_SmartGameObj()->Is_Stealthed())
 	{
 		if (!Get_Int_Parameter("CanSeeStealth"))
@@ -3207,6 +3247,8 @@
 }
 void JMG_Utility_AI_Aggressive_Attack_Spot::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if ((state == IDLE || state == RETURNING_HOME) && (!targetId || !lastSeenTime || Choose_Target(obj,seen)))
 	{
 		targetId = Commands->Get_ID(seen);
@@ -3505,6 +3547,8 @@
 }
 void JMG_Utility_Basic_Spawner_Attach_Script::Created(GameObject *obj)
 {
+	scriptsGroupId = Get_Int_Parameter("Scripts_Group_ID");
+	sprintf(script,"%s",Get_Parameter("Script"));
 	const char *parameters = Get_Parameter("Params");
 	params = newstr(parameters);
 	char delim = Get_Parameter("Delim")[0];
@@ -3515,9 +3559,9 @@
 }
 void JMG_Utility_Basic_Spawner_Attach_Script::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
-	if (message == 6873522)
+	if (message == 6873522 && (scriptsGroupId == -1 || param == -1 || scriptsGroupId == param))
 	{
-		Commands->Attach_Script(sender,Get_Parameter("Script"),params);
+		Commands->Attach_Script(sender,script,params);
 	}
 }
 void JMG_Utility_Send_Custom_On_Preset_Enter::Entered(GameObject *obj,GameObject *enter)
@@ -3680,20 +3724,26 @@
 }
 void JMG_Utility_Objective_System_Controller::Destroyed(GameObject *obj)
 {
+	if (!controllerPlaced)
+		return;
 	BasicObjectiveSystem.~NewObjectiveSystem();
 	controllerPlaced = false;
 }
+void JMG_Utility_Objective_System_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Objective_System_Objective_Update_Enter::Entered(GameObject *obj,GameObject *enter)
 {
+	if (!Commands->Is_A_Star(enter) || triggered)
+		return;
 	if (!JMG_Utility_Objective_System_Controller::controllerPlaced)
 	{
 		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
 		return;
 	}
-	if (!Commands->Is_A_Star(enter) || triggered)
-		return;
 	triggered = true;
-	if (Get_Int_Parameter("CompleteObjectiveID"))
+	if (Get_Int_Parameter("CompleteObjectiveID") && BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("CompleteObjectiveID")) != NewObjectiveSystem::Failed)
 	{
 		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
 		BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
@@ -3732,7 +3782,7 @@
 		}
 		if (!Commands->Is_A_Star(sender))
 			return;
-		if (Get_Int_Parameter("CompleteObjectiveID"))
+		if (Get_Int_Parameter("CompleteObjectiveID") && BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("CompleteObjectiveID")) != NewObjectiveSystem::Failed)
 		{
 			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
 			BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
@@ -3741,7 +3791,7 @@
 		GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? sender : Commands->Find_Object(objectiveMarkerId);
 		if (!ObjectiveMarker && objectiveMarkerId)
 		{
-			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Pickup ERROR: Could not find objective marker object!");
 			return;
 		}
 		if (ObjectiveMarker)
@@ -3760,7 +3810,7 @@
 		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Killed ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
 		return;
 	}
-	if (Get_Int_Parameter("CompleteObjectiveID"))
+	if (Get_Int_Parameter("CompleteObjectiveID") && BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("CompleteObjectiveID")) != NewObjectiveSystem::Failed)
 	{
 		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
 		BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
@@ -3769,7 +3819,7 @@
 	GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? damager : Commands->Find_Object(objectiveMarkerId);
 	if (!ObjectiveMarker && objectiveMarkerId)
 	{
-		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Killed ERROR: Could not find objective marker object!");
 		return;
 	}
 	if (ObjectiveMarker)
@@ -3787,7 +3837,7 @@
 			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Custom ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
 			return;
 		}
-		if (Get_Int_Parameter("CompleteObjectiveID"))
+		if (Get_Int_Parameter("CompleteObjectiveID") && BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("CompleteObjectiveID")) != NewObjectiveSystem::Failed)
 		{
 			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
 			BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
@@ -3796,7 +3846,7 @@
 		GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? sender : Commands->Find_Object(objectiveMarkerId);
 		if (!ObjectiveMarker && objectiveMarkerId)
 		{
-			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Custom ERROR: Could not find objective marker object!");
 			return;
 		}
 		if (ObjectiveMarker)
@@ -4062,6 +4112,11 @@
 	EnemyTimeOutTime = 0;
 	LastPos = Commands->Get_Position(obj);
 	stealthModeOverride = Get_Int_Parameter("StealthModeOverride");
+	float weaponRange = 0.0f;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	if (ammo)
+		weaponRange = ammo->Range;
+	fireRange = Get_Float_Parameter("FireRange") >= 0 ? Get_Float_Parameter("FireRange") : weaponRange;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Enable_Engine(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
@@ -4100,6 +4155,8 @@
 }
 void JMG_Utility_AI_Guardian_Infantry::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
 		return;
 	if (!JmgUtility::CanSeeStealth(stealthModeOverride,obj,seen))
@@ -4136,7 +4193,7 @@
 			params.Set_Face_Location(Commands->Get_Position(Target),5.0f);
 		else
 			params.AttackFaceTarget = false;
-		params.Set_Attack(Target,Get_Float_Parameter("FireRange"),0,true);
+		params.Set_Attack(Target,fireRange,0,true);
 		params.AttackCheckBlocked = Get_Int_Parameter("CheckBlocked") ? true : false;
 		Commands->Action_Attack(obj,params);
 	}
@@ -4533,6 +4590,7 @@
 	playerType = Get_Int_Parameter("PlayerType");
 	safeTeleportDistance = Get_Float_Parameter("SafeTeleportDistance");
 	wanderPointGroup = Get_Int_Parameter("WanderingAIGroupID");
+	aiOnly = Get_Int_Parameter("AiOnly") != 0;
 }
 void JMG_Utility_Zone_Teleport_To_Random_Wander_Point::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -4543,6 +4601,8 @@
 }
 void JMG_Utility_Zone_Teleport_To_Random_Wander_Point::Entered(GameObject *obj,GameObject *enter)
 {
+	if (aiOnly && Commands->Is_A_Star(enter))
+		return;
 	if (CheckPlayerType(enter,playerType))
 		return;
 	Grab_Teleport_Spot(enter,5);
@@ -4598,7 +4658,7 @@
 {
 	safeTeleportDistance = Get_Float_Parameter("SafeTeleportDistance");
 	wanderPointGroup = Get_Int_Parameter("WanderingAIGroupID");
-	Commands->Start_Timer(obj,this,0.25f,1);
+	Commands->Start_Timer(obj,this,0.1f,1);
 }
 void JMG_Utility_Zone_Teleport_To_Random_Wander_Point_Attach::Timer_Expired(GameObject *obj,int number)
 {
@@ -5003,21 +5063,30 @@
 {
 	if (!JMG_Utility_Objective_System_Controller::controllerPlaced)
 	{
-		Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Create ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
-		return;
-	}
-	if (triggered)
+		Commands->Start_Timer(obj,this,0.1f,1);
 		return;
-	triggered = true;
-	if (Get_Int_Parameter("CompleteObjectiveID"))
-	{
-		BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
-		BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
 	}
-	Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),1);
+	Timer_Expired(obj,2);
 }
 void JMG_Utility_Objective_System_Objective_Update_Create::Timer_Expired(GameObject *obj,int number)
 {
+	if (number == 2)
+	{
+		if (!JMG_Utility_Objective_System_Controller::controllerPlaced)
+		{
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Create ERROR: Make sure you have a JMG_Utility_Objective_System_Controller placed on the map!");
+			return;
+		}
+		if (triggered)
+			return;
+		triggered = true;
+		if (Get_Int_Parameter("CompleteObjectiveID") && BasicObjectiveSystem.Get_Objective_Status(Get_Int_Parameter("CompleteObjectiveID")) != NewObjectiveSystem::Failed)
+		{
+			BasicObjectiveSystem.Add_Objective(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
+			BasicObjectiveSystem.Set_Objective_Status(Get_Int_Parameter("CompleteObjectiveID"),NewObjectiveSystem::Accomplished);
+		}
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("Delay"),1);
+	}
 	if (number == 1)
 	{
 		if (Get_Int_Parameter("NewObjectiveID"))
@@ -5026,7 +5095,7 @@
 			GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? obj : Commands->Find_Object(objectiveMarkerId);
 			if (!ObjectiveMarker && objectiveMarkerId)
 			{
-				Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+				Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Create ERROR: Could not find objective marker object!");
 				return;
 			}
 			if (ObjectiveMarker)
@@ -5277,6 +5346,8 @@
 }
 void JMG_Utility_AI_Goto_Enemy::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_AI_Goto_Enemy_Ignore_Object"))
 		return;
 	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
@@ -5691,6 +5762,8 @@
 }
 void JMG_Utility_AI_Goto_Enemy_Not_Star::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_AI_Goto_Enemy_Not_Star_Ignore_Object"))
 		return;
 	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
@@ -6155,6 +6228,11 @@
 	EnemyTimeOutTime = 0;
 	LastPos = Commands->Get_Position(obj);
 	stealthModeOverride = Get_Int_Parameter("StealthModeOverride");
+	float weaponRange = 0.0f;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	if (ammo)
+		weaponRange = ammo->Range;
+	fireRange = Get_Float_Parameter("FireRange") >= 0 ? Get_Float_Parameter("FireRange") : weaponRange;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Enable_Engine(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
@@ -6223,6 +6301,8 @@
 }
 void JMG_Utility_AI_Guardian_Vehicle::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
 		return;
 	if (!JmgUtility::CanSeeStealth(stealthModeOverride,obj,seen))
@@ -6264,10 +6344,10 @@
 		if (aimAtFeet && Target->As_SoldierGameObj())
 		{
 			params.AttackCheckBlocked = false;
-			params.Set_Attack(Commands->Get_Position(Target),Get_Float_Parameter("FireRange"),0,true);
+			params.Set_Attack(Commands->Get_Position(Target),fireRange,0,true);
 		}
 		else
-			params.Set_Attack(Target,Get_Float_Parameter("FireRange"),0,true);
+			params.Set_Attack(Target,fireRange,0,true);
 		Commands->Action_Attack(obj,params);
 	}
 	else
@@ -6325,6 +6405,8 @@
 int JMG_Utility_Send_Custom_On_Deaths_Controller::reminderMessageOrder = 0;
 int JMG_Utility_Send_Custom_On_Deaths_Controller::myId = 0;
 bool JMG_Utility_Send_Custom_On_Deaths_Controller::controllerPlaced = false;
+bool JMG_Utility_Send_Custom_On_Deaths_Controller::announceOnFirstDeath = false;
+bool JMG_Utility_Send_Custom_On_Deaths_Controller::onlyTrackPlayerDeaths = false;
 void JMG_Utility_Send_Custom_On_Deaths_Controller::Created(GameObject *obj)
 {
 	if (controllerPlaced)
@@ -6355,13 +6437,16 @@
 	if (addDeathsWhenNoPlayers > 0)
 		Commands->Start_Timer(obj,this,addDeathsWhenNoPlayers,1);
 	controllerPlaced = true;
+	requiresADeathToStartNoPlayerAdd = Get_Int_Parameter("RequiresADeathToStartNoPlayerAdd") ? true : false;
+	announceOnFirstDeath = Get_Int_Parameter("AnnounceOnFirstDeath") ? true : false;
+	onlyTrackPlayerDeaths = Get_Int_Parameter("OnlyTrackPlayerDeaths") ? true : false;
 	myId = Commands->Get_ID(obj);
 }
 void JMG_Utility_Send_Custom_On_Deaths_Controller::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
 	{
-		if (!Get_Player_Count())
+		if (!Get_Player_Count() && (!requiresADeathToStartNoPlayerAdd || JMG_Utility_Send_Custom_On_Deaths_Controller::deathCount))
 		{
 			if (currentNoPlayersAddDeathSaftyTime)
 				currentNoPlayersAddDeathSaftyTime--;
@@ -6382,6 +6467,10 @@
 {
 	controllerPlaced = false;
 }
+void JMG_Utility_Send_Custom_On_Deaths_Controller::Detach(GameObject *obj)
+{
+	controllerPlaced = false;
+}
 void JMG_Utility_Send_Custom_On_Deaths_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == 8765432 && param == 8765432)
@@ -6403,9 +6492,11 @@
 {
 	if (!controllerPlaced)
 		return;
+	if (onlyTrackPlayerDeaths && !Commands->Is_A_Star(obj))
+		return;
 	deathCount++;
 	int remainingLives = maxDeaths-deathCount;
-	if ((!(remainingLives%deathReminder) || remainingLives <= urgentDeathReminder))
+	if ((!(remainingLives%deathReminder) || remainingLives <= urgentDeathReminder) || (deathCount == 1 && announceOnFirstDeath))
 	{
 		if (remainingLives > 0)
 		{
@@ -6564,6 +6655,10 @@
 	Update_Colors(Vector3(),0.0f);
 	controllerPlaced = false;
 }
+void JMG_Utility_Set_Screen_Color_Fade_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Set_Screen_Color_Fade_Controller::Update_Colors(Vector3 Color,float Opacity)
 {
 	controllerDefaultColor = Color;
@@ -6782,6 +6877,8 @@
 	}
 }
 JMG_Utility_HUD_Count_Down::SendCustomOnSecondNode *JMG_Utility_HUD_Count_Down::sendCustomOnSecondController = NULL;
+JMG_Utility_HUD_Count_Down::CountdownScreenCharacterNode *JMG_Utility_HUD_Count_Down::countdownScreenCharacterController = NULL;
+int JMG_Utility_HUD_Count_Down::highestCharPos = -1;
 bool JMG_Utility_HUD_Count_Down::controllerPlaced = false;
 void JMG_Utility_HUD_Count_Down::Created(GameObject *obj)
 {
@@ -6794,6 +6891,8 @@
 	sprintf(minutePlural,"%s",Get_Parameter("MinutePlural"));
 	sprintf(secondSingular,"%s",Get_Parameter("SecondSingular"));
 	sprintf(secondPlural,"%s",Get_Parameter("SecondPlural"));
+	pauseCustom = Get_Int_Parameter("PauseCustom");
+	paused = Get_Int_Parameter("StartsPaused") != 0;
 	const char *parameters = Get_Parameter("WarningMessage");
 	sprintf(warningMessage,"%s",parameters);
 	char delim = Get_Parameter("Delim")[0];
@@ -6803,14 +6902,17 @@
 			warningMessage[x] = ',';
 	controllerPlaced = true;
 	Commands->Start_Timer(obj,this,1.0f,1);
+	if (paused)
+		Commands->Start_Timer(obj,this,1.0f,2);
 }
 void JMG_Utility_HUD_Count_Down::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
 	{
-		if (seconds)
+		if (seconds && !paused)
 		{
 			seconds--;
+			UpdateCountdownHudNodes();
 			if (seconds >= 3600 && !(seconds % 3600))
 				JmgUtility::SetHUDHelpText(stringId,formatReminderString(warningMessage,seconds/3600,seconds/3600 == 1 ? hourSingular : hourPlural),color);
 			else if (seconds >= 60 && (seconds == 1800 || seconds == 1200 || seconds == 600 || (seconds <= 300 && !(seconds % 60))))
@@ -6821,11 +6923,26 @@
 		}
 		Commands->Start_Timer(obj,this,1.0f,1);
 	}
+	if (number == 2)
+	{
+		UpdateCountdownHudNodes();
+	}
+}
+void JMG_Utility_HUD_Count_Down::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == pauseCustom)
+	{
+		paused = param != 0;
+	}
 }
 void JMG_Utility_HUD_Count_Down::Destroyed(GameObject *obj)
 {
-	controllerPlaced = false;
-	CleanupSecondNodes();
+	if (controllerPlaced)
+		CleanupSecondNodes();
+}
+void JMG_Utility_HUD_Count_Down::Detach(GameObject *obj)
+{
+	Destroyed(obj);
 }
 char *JMG_Utility_HUD_Count_Down::formatReminderString(const char *format,...)
 {
@@ -7103,6 +7220,10 @@
 {
 	JMG_Utility_AI_Follow_Player_On_Poke_Controller::controllerPlaced = false;
 }
+void JMG_Utility_AI_Follow_Player_On_Poke_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_AI_Follow_Player_On_Poke::Created(GameObject *obj)
 {
 	if (!JMG_Utility_AI_Follow_Player_On_Poke_Controller::controllerPlaced)
@@ -7161,6 +7282,8 @@
 }
 void JMG_Utility_AI_Follow_Player_On_Poke::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (seen->As_SmartGameObj() && seen->As_SmartGameObj()->Is_Stealthed() && JmgUtility::SimpleDistance(Commands->Get_Position(obj),Commands->Get_Position(seen)) > 900)
 		return;
 	if (enemyId == Commands->Get_ID(seen))
@@ -7645,6 +7768,7 @@
 						this->Destroy_Script();
 						return;
 					}
+					sleeping = sleepTime;
 				}
 			}
 		Commands->Start_Timer(obj,this,0.1f,1);
@@ -7652,7 +7776,7 @@
 }
 void JMG_Utility_Set_Team_To_Neutral_When_No_Armor::Created(GameObject *obj)
 {
-	hurt = false;
+	hurt = Commands->Get_Shield_Strength(obj) < Commands->Get_Max_Shield_Strength(obj);
 	originalPlayerType = Commands->Get_Player_Type(obj);
 	Commands->Start_Timer(obj,this,0.1f,1);
 }
@@ -7981,7 +8105,7 @@
 		GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? sender : Commands->Find_Object(objectiveMarkerId);
 		if (!ObjectiveMarker && objectiveMarkerId)
 		{
-			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Status_Update_Custom ERROR: Could not find objective marker object!");
 			return;
 		}
 		int stringId = Get_Int_Parameter("NewObjectiveStringID");
@@ -7989,6 +8113,8 @@
 		BasicObjectiveSystem.Set_Objective_Mission(objectiveId,stringId,stringId);
 		if (ObjectiveMarker)
 			BasicObjectiveSystem.Set_Radar_Blip(objectiveId,ObjectiveMarker,NULL);
+		else if (!objectiveMarkerId)
+			BasicObjectiveSystem.Remove_Radar_Blip(objectiveId);
 		JmgUtility::SetHUDHelpText(stringId,BasicObjectiveSystem.Get_Hud_Help_Text_Color((NewObjectiveSystem::Priority)BasicObjectiveSystem.Get_Objective_Priority(objectiveId)));
 	}
 }
@@ -8038,6 +8164,11 @@
 	EnemyTimeOutTime = 0;
 	LastPos = Commands->Get_Position(obj);
 	stealthModeOverride = Get_Int_Parameter("StealthModeOverride");
+	float weaponRange = 0.0f;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	if (ammo)
+		weaponRange = ammo->Range;
+	fireRange = Get_Float_Parameter("FireRange") >= 0 ? Get_Float_Parameter("FireRange") : weaponRange;
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Enable_Engine(obj,true);
 	Commands->Start_Timer(obj,this,1.0f,1);
@@ -8077,6 +8208,8 @@
 }
 void JMG_Utility_AI_Guardian_Generic::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (!Commands->Get_Health(seen))
+		return;
 	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
 		return;
 	if (!JmgUtility::CanSeeStealth(stealthModeOverride,obj,seen))
@@ -8116,7 +8249,7 @@
 			params.Set_Face_Location(Commands->Get_Position(Target),5.0f);
 		else
 			params.AttackFaceTarget = false;
-		params.Set_Attack(Target,Get_Float_Parameter("FireRange"),0,primaryFire);
+		params.Set_Attack(Target,fireRange,0,primaryFire);
 		params.AttackCheckBlocked = Get_Int_Parameter("CheckBlocked") ? true : false;
 		Commands->Action_Attack(obj,params);
 	}
@@ -8812,11 +8945,14 @@
 }
 void JMG_Utility_Apply_Damage_While_In_Zone::Created(GameObject *obj)
 {
+	team = Get_Int_Parameter("Team");
 	int damagerId = Get_Int_Parameter("DamagerId");
 	sprintf(params,"%.2f,%.2f,%s,%d",Get_Float_Parameter("Rate"),Get_Float_Parameter("DamageAmount"),Get_Parameter("Warhead"),damagerId == -2 ? Commands->Get_ID(obj) : damagerId);
 }
 void JMG_Utility_Apply_Damage_While_In_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
+	if (CheckPlayerType(enterer,team))
+		return;
 	Attach_Script_Once(enterer,"JMG_Utility_Apply_Damage_While_In_Zone_Attached",params);
 }
 void JMG_Utility_Apply_Damage_While_In_Zone::Exited(GameObject *obj,GameObject *exiter)
@@ -8983,6 +9119,7 @@
 						this->Destroy_Script();
 						return;
 					}
+					sleeping = sleepTime;
 				}
 			}
 		Commands->Start_Timer(obj,this,0.1f,1);
@@ -9023,6 +9160,10 @@
 {
 	controllerPlaced = false;
 }
+void JMG_Utility_Spawn_With_Last_Selected_Gun_Control::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Spawn_With_Last_Selected_Gun_Player::Created(GameObject *obj)
 {
 	if (!Commands->Is_A_Star(obj))
@@ -9180,7 +9321,7 @@
 		GameObject *ObjectiveMarker = objectiveMarkerId == -1 ? sender : Commands->Find_Object(objectiveMarkerId);
 		if (!ObjectiveMarker && objectiveMarkerId)
 		{
-			Console_Input("msg JMG_Utility_Objective_System_Objective_Update_Enter ERROR: Could not find objective marker object!");
+			Console_Input("msg JMG_Utility_Objective_System_Objective_Marker_Update_Custom ERROR: Could not find objective marker object!");
 			return;
 		}
 		BasicObjectiveSystem.Add_Objective(objectiveId,NewObjectiveSystem::Primary,NewObjectiveSystem::Hidden,0,"",0);
@@ -9290,6 +9431,10 @@
 {
 	controllerPlaced = false;
 }
+void JMG_Utility_Detect_AFK_Controller::Detach(GameObject *obj)
+{
+	Destroyed(obj);
+}
 void JMG_Utility_Credit_Trickle_When_Not_AFK::Created(GameObject *obj)
 {
 	custom = Get_Int_Parameter("Custom");
@@ -9343,6 +9488,7 @@
 SList<JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode> JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList;
 void JMG_Utility_Basic_Spawner_In_Radius::Created(GameObject *obj)
 {
+	attachScriptsGroupId = Get_Int_Parameter("Attach_Scripts_Group_ID");
 	scriptId = Get_Int_Parameter("Script_ID");
 	if (scriptId == -1)
 		scriptId = this->Get_ID();
@@ -9369,7 +9515,7 @@
 	retryAttempts = Get_Int_Parameter("Collision_Retry_Attempts");
 	addHeight = Get_Float_Parameter("Collision_Add_Height");
 	changeSpawnCapCustom = Get_Int_Parameter("Change_Spawn_Cap_Custom");
-	sprintf(preset,Get_Parameter("Spawn_Preset"));
+	sprintf(preset,"%s",Get_Parameter("Spawn_Preset"));
 	spawnCount = 0;
 	initialSpawn = Get_Int_Parameter("Initial_Spawn");
 	if (initialSpawn == -1)
@@ -9384,6 +9530,8 @@
 	spawnGroupId = Get_Int_Parameter("Spawn_Group_ID");
 	enabled = Get_Int_Parameter("Starts_Disabled") == 0 ? true : false;
 	enableDisableCustom = Get_Int_Parameter("Enable_Disable_Custom");
+	raycastRange = Get_Vector3_Parameter("Raycast_Direction_Override[Bottom|Top|Unused]");
+	playersAddToSpawnAtATime = Get_Float_Parameter("PlayersAddToSpawnAtATime");
 	if (enabled)
 		Initial_Spawn(obj);
 	Commands->Start_Timer(obj,this,rate+(randomRate ? Commands->Get_Random(-randomRate,randomRate) : 0.0f),1);
@@ -9395,13 +9543,10 @@
 		if (enabled)
 		{
 			JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes spawnResult = AttemptSpawn(obj);
-			if (spawnResult == SpawnFailureTypes::SPAWN_BLOCKED)
-			{
-				Commands->Start_Timer(obj,this,0.1f,1);
-				return;
-			}
 			if (spawnResult == SpawnFailureTypes::SUCCESS)
 				Commands->Start_Timer(obj,this,rate+(randomRate ? Commands->Get_Random(-randomRate,randomRate) : 0.0f),1);
+			else if (spawnResult == SpawnFailureTypes::SPAWN_BLOCKED)
+				Commands->Start_Timer(obj,this,0.1f,1);
 		}
 		else
 			Commands->Start_Timer(obj,this,0.1f,1);
@@ -9424,7 +9569,7 @@
 	}
 	if (message == 6873525 && param == scriptId)
 	{
-		if (AttemptSpawn(obj) == SpawnFailureTypes::SPAWN_BLOCKED)
+		if (!enabled || AttemptSpawn(obj) == SpawnFailureTypes::SPAWN_BLOCKED)
 			Commands->Send_Custom_Event(obj,obj,6873525,scriptId,0.1f);
 	}
 	if (enableDisableCustom && message == enableDisableCustom)
@@ -9436,7 +9581,7 @@
 }
 JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes JMG_Utility_Basic_Spawner_In_Radius::AttemptSpawn(GameObject *obj)
 {
-	if (!(spawnedObjects < spawnAtATime))
+	if (!(spawnedObjects < spawnAtATime+GetPlayerLimitModifier()))
 		return SpawnFailureTypes::LIMIT_REACHED;
 	if (!((spawnLimit >= 0 && spawnCount < spawnLimit) || spawnLimit < 0))
 		return SpawnFailureTypes::LIMIT_REACHED;
@@ -9449,7 +9594,12 @@
 	topRay.Z = spawnLocation.Z;
 	Vector3 bottom,top;
 	PhysicsSceneClass::Get_Instance()->Get_Level_Extents(bottom,top);
-	if (spawnLocation.Z < bottom.Z)
+	if (raycastRange.X != 0.0f && raycastRange.Y != 0.0f)
+	{
+		bottomRay.Z = raycastRange.X;
+		topRay.Z = raycastRange.Y;
+	}
+	else if (spawnLocation.Z < bottom.Z)
 		bottomRay.Z = top.Z+1.0f;
 	else
 		bottomRay.Z = bottom.Z-1.0f;
